diff --git a/test/unit/claude_launcher_test.rb b/test/unit/claude_launcher_test.rb
index 1d6b2589..11554954 100644
--- a/test/unit/claude_launcher_test.rb
+++ b/test/unit/claude_launcher_test.rb
@@ -250,6 +250,24 @@ class ClaudeLauncherTest < Minitest::Test
     assert_nil Hive::ClaudeLauncher.reestablish_dead_session!(dead, nil)
   end
 
+  def test_reestablish_dead_session_replaces_a_retained_dead_pane
+    runner = Object.new
+    runner.instance_variable_set(:@dead, true)
+    runner.define_singleton_method(:session_exists?) { true }
+    runner.define_singleton_method(:pane_dead?) { @dead }
+    runner.define_singleton_method(:kill_session) do
+      @killed = true
+      @dead = false
+    end
+    calls = 0
+
+    Hive::ClaudeLauncher.reestablish_dead_session!(runner, -> { calls += 1 })
+
+    assert_equal 1, calls
+    assert runner.instance_variable_get(:@killed),
+           "remain-on-exit's retained dead pane must be removed before restart"
+  end
+
   def test_prepare_claude_session_uses_caller_deadline_before_ready_timeout
     runner = Object.new
     runner.define_singleton_method(:name) { "hive-test-session" }
@@ -1053,6 +1071,8 @@ class ClaudeLauncherTest < Minitest::Test
       end.new("Claude Code\n❯")
       output = File.join(task.folder, "expected.md")
       File.write(output, "done")
+      File.write(Hive::ClaudeLauncher.done_path(task), "done")
+      File.write(Hive::ClaudeLauncher.result_path(task), JSON.generate("status" => "success"))
 
       output_result = Hive::ClaudeLauncher.wait_for_status(
         task, runner, 0, :output_file_exists, output, "reviewer"
@@ -1067,6 +1087,7 @@ class ClaudeLauncherTest < Minitest::Test
       end.new("")
       missing_output = File.join(task.folder, "missing.md")
       File.write(Hive::ClaudeLauncher.done_path(task), "done")
+      File.write(Hive::ClaudeLauncher.result_path(task), JSON.generate("status" => "success"))
 
       done_result = Hive::ClaudeLauncher.wait_for_status(
         task, runner, 0, :exit_code_only, missing_output, "ci"
@@ -1080,7 +1101,32 @@ class ClaudeLauncherTest < Minitest::Test
     end
   end
 
-  def test_wait_for_expected_output_accepts_ready_prompt_without_done_file
+  def test_wait_for_state_marker_uses_shared_busy_to_idle_fallback
+    with_tmp_task do |task|
+      Hive::Markers.set(task.state_file, :complete)
+      terminal_tail = "Claude Code v2\n#{File.read(task.state_file)}\n❯"
+      runner = fallback_runner(
+        tails: [ "Claude Code v2\nworking", terminal_tail, terminal_tail ],
+        pane_pid: 49,
+        exit_status: 0
+      )
+
+      result = Hive::ClaudeLauncher.wait_for_status(
+        task, runner, 10, :state_file_marker, nil, "execute"
+      )
+
+      assert_equal :complete, result.fetch(:status)
+      assert_equal :fallback, result.fetch(:completion)
+      assert result.fetch(:completion_audited)
+      assert result.fetch(:fallback_decision).accepted?
+      assert_equal [ task.state_file ], result.fetch(:completion_probe).fetch(:artifacts_checked)
+      event = JSON.parse(File.readlines(File.join(task.folder, "events.jsonl")).last)
+      assert_equal "claude_completion_fallback", event.fetch("event_type")
+      assert_includes event.fetch("message"), "level=WARN"
+    end
+  end
+
+  def test_wait_for_expected_output_rejects_ready_prompt_without_lifecycle_and_verified_exit
     with_tmp_task do |task|
       output = File.join(task.folder, "result.md")
       File.write(output, "review findings")
@@ -1090,7 +1136,46 @@ class ClaudeLauncherTest < Minitest::Test
 
       result = Hive::ClaudeLauncher.wait_for_expected_output(task, runner, 1, output, "review")
 
-      assert_equal({ status: :ok, log_label: "review" }, result)
+      assert_equal :timeout, result.fetch(:status)
+      refute result.fetch(:fallback_decision).accepted?
+      assert_includes result.fetch(:fallback_decision).rejections, :work_started
+    end
+  end
+
+  def test_wait_for_expected_output_uses_shared_busy_to_idle_fallback
+    with_tmp_task do |task|
+      output = File.join(task.folder, "result.md")
+      File.write(output, "review findings")
+      tails = [ "Claude Code v2\nworking", "Claude Code v2\n❯", "Claude Code v2\n❯" ]
+      runner = fallback_runner(tails: tails, pane_pid: 51, exit_status: 0)
+
+      result = Hive::ClaudeLauncher.wait_for_expected_output(task, runner, 10, output, "review")
+
+      assert_equal :ok, result.fetch(:status)
+      assert_equal :fallback, result.fetch(:completion)
+      assert result.fetch(:completion_audited)
+      assert result.fetch(:fallback_decision).accepted?
+      assert_equal [ output ], result.fetch(:completion_probe).fetch(:artifacts_checked)
+      event = JSON.parse(File.readlines(File.join(task.folder, "events.jsonl")).last)
+      assert_equal "claude_completion_fallback", event.fetch("event_type")
+    end
+  end
+
+  def test_wait_for_expected_output_rejects_crash_without_raising
+    with_tmp_task do |task|
+      output = File.join(task.folder, "result.md")
+      File.write(output, "partial review")
+      runner = Struct.new(:tail) do
+        def session_exists? = true
+        def capture_pane_tail(bytes:) = tail
+      end.new("Claude crashed while writing the review")
+
+      result = Hive::ClaudeLauncher.wait_for_expected_output(task, runner, 10, output, "review")
+
+      assert_equal :error, result.fetch(:status)
+      assert_match(/reported a failure/, result.fetch(:error_message))
+      refute result.fetch(:fallback_decision).accepted?
+      assert_includes result.fetch(:fallback_decision).rejections, :no_failure_output
     end
   end
 
@@ -1185,6 +1270,7 @@ class ClaudeLauncherTest < Minitest::Test
       output = File.join(task.folder, "result.md")
       File.write(output, "review findings")
       File.write(Hive::ClaudeLauncher.done_path(task), "done")
+      File.write(Hive::ClaudeLauncher.result_path(task), JSON.generate("status" => "success"))
       runner = Struct.new(:name) do
         def session_exists? = false
       end.new("gone-reviewer")
@@ -1216,7 +1302,7 @@ class ClaudeLauncherTest < Minitest::Test
       File.write(Hive::ClaudeLauncher.result_path(task), JSON.generate("status" => "failed"))
 
       failed = Hive::ClaudeLauncher.wait_for_done_signal(task, nil, 1, "ci")
-      assert_equal :failed, failed.fetch(:status)
+      assert_equal :error, failed.fetch(:status)
       assert_match(/failed/, failed.fetch(:error_message))
     end
 
@@ -1227,6 +1313,238 @@ class ClaudeLauncherTest < Minitest::Test
     end
   end
 
+  def test_wait_for_done_signal_accepts_only_busy_to_idle_probe_with_zero_exit
+    with_tmp_task do |task|
+      tails = [
+        "Claude Code v2\nworking on the requested fix\n",
+        "Claude Code v2\n❯",
+        "Claude Code v2\n❯"
+      ]
+      runner = fallback_runner(tails: tails, pane_pid: 42, exit_status: 0, unreadable_after_kill: true)
+
+      probe_calls = 0
+      result = Hive::ClaudeLauncher.wait_for_done_signal(
+        task, runner, 10, "fix",
+        completion_phase: "review_fix",
+        completion_probe: lambda { |task:, phase:|
+          probe_calls += 1
+          assert_equal task.folder, task.folder
+          assert_equal "review_fix", phase
+          { accepted: true, artifacts_checked: [ "reviews/fix-result-01.json" ], commit_range: "a..b" }
+        }
+      )
+
+      assert_equal :ok, result.fetch(:status)
+      assert_equal :fallback, result.fetch(:completion)
+      assert result.fetch(:completion_audited)
+      assert_equal 1, probe_calls
+      assert result.fetch(:fallback_decision).accepted?
+      assert_equal 42, result.fetch(:fallback_decision).evidence.pane_pid
+      assert_equal "/quit", runner.instance_variable_get(:@quit)
+      refute runner.instance_variable_get(:@killed),
+             "the shared-session ensure path owns teardown after fallback classification"
+    end
+  end
+
+  def test_fallback_rejects_a_retained_non_success_result_without_a_sentinel
+    with_tmp_task do |task|
+      File.write(Hive::ClaudeLauncher.result_path(task), JSON.generate("status" => "cancelled"))
+      tails = [ "Claude Code v2\nworking", "Claude Code v2\n❯", "Claude Code v2\n❯" ]
+      runner = fallback_runner(tails: tails, pane_pid: 63, exit_status: 0)
+
+      result = Hive::ClaudeLauncher.wait_for_done_signal(
+        task, runner, 10, "fix", completion_probe: ->(**) { { accepted: true } }
+      )
+
+      assert_equal :timeout, result.fetch(:status)
+      assert_includes result.fetch(:fallback_decision).rejections, :no_failure_result
+      refute File.exist?(File.join(task.folder, "events.jsonl"))
+    end
+  end
+
+  def test_wait_for_done_signal_restores_launcher_state_before_semantic_probe
+    with_tmp_task do |task|
+      tails = [ "Claude Code v2\nworking", "Claude Code v2\n❯", "Claude Code v2\n❯" ]
+      runner = fallback_runner(tails: tails, pane_pid: 61, exit_status: 0)
+      cleanup_called = false
+      probe_saw_cleanup = false
+
+      result = Hive::ClaudeLauncher.wait_for_done_signal(
+        task, runner, 10, "fix",
+        completion_phase: "review_fix",
+        before_completion_probe: -> { cleanup_called = true },
+        completion_probe: lambda { |**|
+          probe_saw_cleanup = cleanup_called
+          { accepted: true, artifacts_checked: [ "reviews/fix-result-01.json" ] }
+        }
+      )
+
+      assert_equal :ok, result.fetch(:status)
+      assert probe_saw_cleanup, "launcher-owned settings must be restored before worktree validation"
+    end
+  end
+
+  def test_wait_for_done_signal_never_probes_a_cold_idle_prompt
+    with_tmp_task do |task|
+      runner = Object.new
+      runner.define_singleton_method(:capture_pane_tail) { |bytes:| "Claude Code v2\n❯" }
+      probe_called = false
+
+      result = Hive::ClaudeLauncher.wait_for_done_signal(
+        task, runner, 0, "fix",
+        completion_probe: lambda { |**|
+          probe_called = true
+          { accepted: true }
+        }
+      )
+
+      assert_equal :timeout, result.fetch(:status)
+      refute probe_called
+      refute result.fetch(:fallback_decision).accepted?
+      assert_includes result.fetch(:fallback_decision).rejections, :work_started
+    end
+  end
+
+  def test_late_stop_sentinel_wins_over_fallback_after_controlled_exit
+    with_tmp_task do |task|
+      tails = [ "Claude Code v2\nworking", "Claude Code v2\n❯", "Claude Code v2\n❯" ]
+      runner = Object.new
+      runner.define_singleton_method(:name) { "late-signal" }
+      runner.define_singleton_method(:pane_pid) { 42 }
+      runner.define_singleton_method(:capture_pane_tail) { |bytes:| tails.shift || "Claude Code v2\n❯" }
+      runner.define_singleton_method(:enable_remain_on_exit) { true }
+      runner.define_singleton_method(:send_prompt) do |_text|
+        File.write(Hive::ClaudeLauncher.result_path(task), JSON.generate("status" => "success"))
+        File.write(Hive::ClaudeLauncher.done_path(task), "done")
+      end
+      runner.define_singleton_method(:pane_dead?) { true }
+      runner.define_singleton_method(:pane_dead_status) { 0 }
+      runner.define_singleton_method(:kill_session) { true }
+
+      result = Hive::ClaudeLauncher.wait_for_done_signal(
+        task, runner, 10, "fix",
+        completion_probe: ->(**) { { accepted: true } }
+      )
+
+      assert_equal :ok, result.fetch(:status)
+      refute result.key?(:completion), "a late ordinary Stop signal must not emit fallback acceptance"
+    end
+  end
+
+  def test_stop_sentinel_arriving_during_semantic_probe_wins_normal_completion
+    with_tmp_task do |task|
+      tails = [ "Claude Code v2\nworking", "Claude Code v2\n❯", "Claude Code v2\n❯" ]
+      runner = fallback_runner(tails: tails, pane_pid: 64, exit_status: 0)
+
+      result = Hive::ClaudeLauncher.wait_for_done_signal(
+        task, runner, 10, "fix",
+        completion_probe: lambda { |**|
+          File.write(Hive::ClaudeLauncher.result_path(task), JSON.generate("status" => "success"))
+          File.write(Hive::ClaudeLauncher.done_path(task), "done")
+          { accepted: true }
+        }
+      )
+
+      assert_equal :ok, result.fetch(:status)
+      refute result.key?(:completion), "a Stop signal published by the probe must stay on the normal path"
+      refute File.exist?(File.join(task.folder, "events.jsonl"))
+    end
+  end
+
+  def test_ordinary_error_prose_does_not_override_a_valid_stop_result
+    pane = "Claude Code v2\nI fixed the unexpected error and completed the work.\n❯"
+
+    with_tmp_task do |task|
+      File.write(Hive::ClaudeLauncher.done_path(task), "done")
+      File.write(Hive::ClaudeLauncher.result_path(task), JSON.generate("status" => "success"))
+      runner = Struct.new(:tail) do
+        def capture_pane_tail(bytes:) = tail
+      end.new(pane)
+
+      result = Hive::ClaudeLauncher.wait_for_done_signal(task, runner, 1, "fix")
+
+      assert_equal :ok, result.fetch(:status)
+      assert_nil Hive::ClaudeLauncher.completion_failure_result(
+        task, runner, Hive::ClaudeLauncher.completion_lifecycle, "fix", runner.tail
+      )
+    end
+
+    with_tmp_task do |task|
+      output = File.join(task.folder, "review.md")
+      File.write(output, "review complete")
+      File.write(Hive::ClaudeLauncher.done_path(task), "done")
+      File.write(Hive::ClaudeLauncher.result_path(task), JSON.generate("status" => "success"))
+      runner = Struct.new(:tail) do
+        def session_exists? = true
+        def capture_pane_tail(bytes:) = tail
+      end.new(pane)
+
+      result = Hive::ClaudeLauncher.wait_for_expected_output(task, runner, 1, output, "review")
+
+      assert_equal :ok, result.fetch(:status)
+    end
+
+    with_tmp_task do |task|
+      Hive::Markers.set(task.state_file, :complete)
+      File.write(Hive::ClaudeLauncher.done_path(task), "done")
+      File.write(Hive::ClaudeLauncher.result_path(task), JSON.generate("status" => "success"))
+      runner = Struct.new(:tail) do
+        def capture_pane_tail(bytes:) = tail
+      end.new(pane)
+
+      result = Hive::ClaudeLauncher.wait_for_status(
+        task, runner, 1, :state_file_marker, nil, "execute"
+      )
+
+      assert_equal :complete, result.fetch(:status)
+    end
+  end
+
+  def test_fallback_audit_failure_rejects_acceptance
+    with_tmp_task do |task|
+      tails = [ "Claude Code v2\nworking", "Claude Code v2\n❯", "Claude Code v2\n❯" ]
+      runner = fallback_runner(tails: tails, pane_pid: 65, exit_status: 0)
+
+      with_replaced_singleton_method(Hive::Events, :emit, ->(**) { nil }) do
+        result = Hive::ClaudeLauncher.wait_for_done_signal(
+          task, runner, 10, "fix", completion_probe: ->(**) { { accepted: true } }
+        )
+
+        assert_equal :timeout, result.fetch(:status)
+        refute result.key?(:completion)
+        refute result.fetch(:fallback_decision).accepted?
+      end
+    end
+  end
+
+  def test_nonterminal_stop_wakeup_is_cleared_and_waiting_continues
+    with_tmp_task do |task|
+      Hive::Markers.set(task.state_file, :agent_working, pid: Process.pid)
+      File.write(Hive::ClaudeLauncher.done_path(task), "done")
+      File.write(Hive::ClaudeLauncher.result_path(task), JSON.generate("status" => "success"))
+      runner = Struct.new(:tail) do
+        def capture_pane_tail(bytes:) = tail
+      end.new("Claude Code v2\nworking")
+      sleep_calls = 0
+
+      with_replaced_singleton_method(Hive::ClaudeLauncher, :sleep, lambda { |_seconds|
+        sleep_calls += 1
+        Hive::Markers.set(task.state_file, :complete)
+        File.write(Hive::ClaudeLauncher.done_path(task), "done")
+        File.write(Hive::ClaudeLauncher.result_path(task), JSON.generate("status" => "success"))
+      }) do
+        result = Hive::ClaudeLauncher.wait_for_status(
+          task, runner, 10, :state_file_marker, nil, "execute"
+        )
+
+        assert_equal :complete, result.fetch(:status)
+        assert_equal 1, sleep_calls
+        refute_equal "invalid_stop_hook_result",
+                     Hive::Markers.current(task.state_file).attrs["reason"]
+      end
+    end
+  end
+
   # A quota wall stalls the default claude/tmux execute spawn without ever
   # touching `.done`; the exit_code_only wait must surface it as an :error
   # carrying the limit message (not drain to the generic stop-hook timeout)
@@ -1249,6 +1567,23 @@ class ClaudeLauncherTest < Minitest::Test
     end
   end
 
+  def test_wait_for_done_signal_rejects_crash_before_idle_fallback
+    with_tmp_task do |task|
+      runner = Struct.new(:tail) do
+        def capture_pane_tail(bytes:) = tail
+      end.new("fatal error: Claude crashed")
+
+      result = Hive::ClaudeLauncher.wait_for_done_signal(
+        task, runner, 10, "fix", completion_probe: ->(**) { { accepted: true } }
+      )
+
+      assert_equal :error, result.fetch(:status)
+      assert_match(/reported a failure/, result.fetch(:error_message))
+      refute result.fetch(:fallback_decision).accepted?
+      assert_includes result.fetch(:fallback_decision).rejections, :no_failure_output
+    end
+  end
+
   def test_waits_ignore_quoted_limit_menu_after_agent_moved_on
     quoted_pane = pane_fixture("limit_quoted_7456.txt")
 
@@ -1256,6 +1591,7 @@ class ClaudeLauncherTest < Minitest::Test
       output = File.join(task.folder, "result.md")
       File.write(output, "review findings")
       File.write(Hive::ClaudeLauncher.done_path(task), "done")
+      File.write(Hive::ClaudeLauncher.result_path(task), JSON.generate("status" => "success"))
       runner = Struct.new(:tail) do
         def session_exists? = true
         def capture_pane_tail(bytes:) = tail
@@ -1269,6 +1605,7 @@ class ClaudeLauncherTest < Minitest::Test
 
     with_tmp_task do |task|
       File.write(Hive::ClaudeLauncher.done_path(task), "done")
+      File.write(Hive::ClaudeLauncher.result_path(task), JSON.generate("status" => "success"))
       runner = Struct.new(:tail) do
         def capture_pane_tail(bytes:) = tail
       end.new(quoted_pane)
@@ -1280,27 +1617,93 @@ class ClaudeLauncherTest < Minitest::Test
     end
   end
 
-  def test_read_result_json_status_handles_all_fallback_shapes
+  def test_read_result_json_status_fails_closed_for_every_invalid_shape
     with_tmp_task do |task|
-      assert_nil Hive::ClaudeLauncher.read_result_json_status(task)
+      assert_equal :invalid_result, Hive::ClaudeLauncher.read_result_json_status(task)
 
       FileUtils.touch(Hive::ClaudeLauncher.result_path(task))
-      assert_nil Hive::ClaudeLauncher.read_result_json_status(task)
+      assert_equal :invalid_result, Hive::ClaudeLauncher.read_result_json_status(task)
 
       File.write(Hive::ClaudeLauncher.result_path(task), JSON.generate("status" => "success"))
       assert_equal :ok, Hive::ClaudeLauncher.read_result_json_status(task)
 
       File.write(Hive::ClaudeLauncher.result_path(task), JSON.generate("status" => ""))
-      assert_nil Hive::ClaudeLauncher.read_result_json_status(task)
+      assert_equal :invalid_result, Hive::ClaudeLauncher.read_result_json_status(task)
+
+      File.write(Hive::ClaudeLauncher.result_path(task), JSON.generate("detail" => "statusless"))
+      assert_equal :invalid_result, Hive::ClaudeLauncher.read_result_json_status(task)
 
       File.write(Hive::ClaudeLauncher.result_path(task), JSON.generate("status" => "cancelled"))
       assert_equal :cancelled, Hive::ClaudeLauncher.read_result_json_status(task)
 
       File.write(Hive::ClaudeLauncher.result_path(task), JSON.generate([ "not", "a", "hash" ]))
-      assert_nil Hive::ClaudeLauncher.read_result_json_status(task)
+      assert_equal :invalid_result, Hive::ClaudeLauncher.read_result_json_status(task)
+
+      File.write(Hive::ClaudeLauncher.result_path(task), "{")
+      assert_equal :invalid_result, Hive::ClaudeLauncher.read_result_json_status(task)
+    end
+  end
+
+  def test_done_signal_rejects_missing_or_malformed_result_json
+    with_tmp_task do |task|
+      File.write(Hive::ClaudeLauncher.done_path(task), "done")
+      missing = Hive::ClaudeLauncher.wait_for_done_signal(task, nil, 1, "fix")
+      assert_equal :error, missing.fetch(:status)
+      assert_match(/invalid or missing result\.json/, missing.fetch(:error_message))
+    end
 
+    with_tmp_task do |task|
+      File.write(Hive::ClaudeLauncher.done_path(task), "done")
       File.write(Hive::ClaudeLauncher.result_path(task), "{")
-      assert_nil Hive::ClaudeLauncher.read_result_json_status(task)
+      malformed = Hive::ClaudeLauncher.wait_for_done_signal(task, nil, 1, "fix")
+      assert_equal :error, malformed.fetch(:status)
+      assert_match(/invalid or missing result\.json/, malformed.fetch(:error_message))
+    end
+  end
+
+  def test_done_signal_normalizes_valid_non_success_result_to_error
+    with_tmp_task do |task|
+      File.write(Hive::ClaudeLauncher.done_path(task), "done")
+      File.write(Hive::ClaudeLauncher.result_path(task), JSON.generate("status" => "cancelled"))
+
+      result = Hive::ClaudeLauncher.wait_for_done_signal(task, nil, 1, "fix")
+
+      assert_equal :error, result.fetch(:status)
+      assert_match(/reported :cancelled/, result.fetch(:error_message))
+    end
+  end
+
+  def test_all_wait_modes_reject_sentinel_with_invalid_result_json
+    with_tmp_task do |task|
+      output = File.join(task.folder, "review.md")
+      File.write(output, "complete review")
+      File.write(Hive::ClaudeLauncher.done_path(task), "done")
+      runner = Struct.new(:tail) do
+        def session_exists? = true
+        def capture_pane_tail(bytes:) = tail
+      end.new("Claude Code v2\n❯")
+
+      result = Hive::ClaudeLauncher.wait_for_expected_output(task, runner, 1, output, "review")
+
+      assert_equal :error, result.fetch(:status)
+      assert_match(/invalid or missing result\.json/, result.fetch(:error_message))
+    end
+
+    with_tmp_task do |task|
+      Hive::Markers.set(task.state_file, :complete)
+      File.write(Hive::ClaudeLauncher.done_path(task), "done")
+      runner = Struct.new(:tail) do
+        def capture_pane_tail(bytes:) = tail
+      end.new("Claude Code v2\n❯")
+
+      result = Hive::ClaudeLauncher.wait_for_status(
+        task, runner, 1, :state_file_marker, nil, "execute"
+      )
+
+      assert_equal :error, result.fetch(:status)
+      marker = Hive::Markers.current(task.state_file)
+      assert_equal "invalid_stop_hook_result", marker.attrs.fetch("reason")
+      assert_match(/invalid or missing result\.json/, marker.attrs.fetch("message"))
     end
   end
 
@@ -1409,6 +1812,18 @@ class ClaudeLauncherTest < Minitest::Test
     end
   end
 
+  def test_reset_signal_files_removes_result_and_sentinel
+    with_tmp_task do |task|
+      File.write(Hive::ClaudeLauncher.done_path(task), "done")
+      File.write(Hive::ClaudeLauncher.result_path(task), JSON.generate("status" => "success"))
+
+      Hive::ClaudeLauncher.reset_signal_files(task)
+
+      refute File.exist?(Hive::ClaudeLauncher.done_path(task))
+      refute File.exist?(Hive::ClaudeLauncher.result_path(task))
+    end
+  end
+
   def test_cleanup_scratch_ignores_directory_races
     with_tmp_task do |task|
       scratch = File.join(task.folder, ".claude", "settings.json")
@@ -1443,6 +1858,53 @@ class ClaudeLauncherTest < Minitest::Test
     end
   end
 
+  def test_shared_session_pre_probe_cleanup_restores_settings_only_once
+    with_tmp_task do |task|
+      settings = File.join(task.folder, ".claude", "settings.json")
+      backup = "#{settings}#{Hive::StopHookInstaller::BACKUP_SUFFIX}"
+      FileUtils.mkdir_p(File.dirname(settings))
+      File.write(settings, %({"hooks":{"Stop":[]}}))
+      File.write(backup, %({"project":true}))
+      runner = Object.new
+      runner.define_singleton_method(:start_detached) { |command:| true }
+      runner.define_singleton_method(:kill_session) { true }
+
+      with_replaced_singleton_method(Hive::ClaudeLauncher, :build_runner, ->(**) { runner }) do
+        with_replaced_singleton_method(Hive::ClaudeLauncher, :preflight!, ->(*) { }) do
+          with_replaced_singleton_method(Hive::ClaudeLauncher, :reset_signal_files, ->(*) { }) do
+            with_replaced_singleton_method(Hive::StopHookInstaller, :install, ->(**) { [ settings ] }) do
+              with_replaced_singleton_method(Hive::ClaudeLauncher, :wrapper_command, ->(**) { [ "claude" ] }) do
+                with_replaced_singleton_method(Hive::ClaudeLauncher, :wait_until_session_exists!, ->(*) { }) do
+                  with_replaced_singleton_method(Hive::ClaudeLauncher, :record_claude_pid, ->(*) { }) do
+                    with_replaced_singleton_method(Hive::ClaudeLauncher, :prepare_claude_session!, ->(*) { }) do
+                      with_replaced_singleton_method(Hive::ClaudeLauncher, :shutdown_claude, ->(*) { }) do
+                        with_replaced_singleton_method(Hive::ClaudeLauncher, :sweep_orphan_processes, ->(*) { }) do
+                          Hive::ClaudeLauncher.with_shared_session(
+                            task: task,
+                            cfg: {},
+                            session_name: "settings-restore",
+                            cwd: task.folder,
+                            add_dirs: []
+                          ) do |handle|
+                            handle.before_completion_probe.call
+                            assert_equal %({"project":true}), File.read(settings)
+                          end
+                        end
+                      end
+                    end
+                  end
+                end
+              end
+            end
+          end
+        end
+      end
+
+      assert_equal %({"project":true}), File.read(settings),
+                   "ensure must not delete settings already restored before the probe"
+    end
+  end
+
   def test_cleanup_scratch_deletes_when_no_backup_exists
     with_tmp_task do |task|
       settings = File.join(task.folder, ".claude", "settings.json")
@@ -1467,4 +1929,30 @@ class ClaudeLauncherTest < Minitest::Test
     assert_match(/example-task/, err)
     assert_match(/cleanup/, err)
   end
+
+  private
+
+  def fallback_runner(tails:, pane_pid:, exit_status:, unreadable_after_kill: false)
+    runner = Object.new
+    runner.instance_variable_set(:@tails, tails.dup)
+    runner.instance_variable_set(:@pane_pid_value, pane_pid)
+    runner.instance_variable_set(:@exit_status, exit_status)
+    runner.instance_variable_set(:@unreadable_after_kill, unreadable_after_kill)
+    runner.define_singleton_method(:name) { "fallback-session" }
+    runner.define_singleton_method(:pane_pid) do
+      raise Hive::TmuxError, "session gone" if @killed && @unreadable_after_kill
+
+      @pane_pid_value
+    end
+    runner.define_singleton_method(:session_exists?) { !@killed }
+    runner.define_singleton_method(:capture_pane_tail) do |bytes:|
+      @tails.shift || "Claude Code v2\n❯"
+    end
+    runner.define_singleton_method(:enable_remain_on_exit) { true }
+    runner.define_singleton_method(:send_prompt) { |text| @quit = text }
+    runner.define_singleton_method(:pane_dead?) { true }
+    runner.define_singleton_method(:pane_dead_status) { @exit_status }
+    runner.define_singleton_method(:kill_session) { @killed = true }
+    runner
+  end
 end
diff --git a/test/unit/current_main_coverage_gap_test.rb b/test/unit/current_main_coverage_gap_test.rb
index 1c17f2a6..fe2c8ae4 100644
--- a/test/unit/current_main_coverage_gap_test.rb
+++ b/test/unit/current_main_coverage_gap_test.rb
@@ -86,7 +86,7 @@ class CurrentMainCoverageGapTest < Minitest::Test
   end
 
   def accepted_findings(text = "## High\n- [x] apply a fix\n", count: 1)
-    Hive::Stages::Review::AcceptedFindings.new(text: text, count: count)
+    Hive::Stages::Review::AcceptedFindings.new(text: text, count: count, finding_ids: [])
   end
 
   def with_fake_profile(profile = FakeProfile.new(:codex))
@@ -362,7 +362,7 @@ class CurrentMainCoverageGapTest < Minitest::Test
             with_replaced_singleton_method(Hive::Stages::Review, :reviewer_compare_ref, ->(_cfg, _ops) { "main" }) do
               with_replaced_singleton_method(Hive::Stages::Review, :git_head, ->(_path) { "head-before-fix" }) do
                 with_replaced_singleton_method(Hive::Stages::Review, :worktree_status, ->(_path) { status_checks.shift }) do
-                  with_replaced_singleton_method(Hive::Stages::Review, :spawn_fix_agent, ->(_task, _cfg, _ctx, accepted:) { { status: :ok } }) do
+                  with_replaced_singleton_method(Hive::Stages::Review, :spawn_fix_agent, ->(_task, _cfg, _ctx, accepted:, **_kwargs) { { status: :ok } }) do
                     with_replaced_singleton_method(Hive::Stages::Review, :auto_commit_fix_worktree, ->(_task, _cfg, _ctx, _accepted) {
                       { success: false, message: "git add -A failed: permission denied" }
                     }) do
@@ -405,7 +405,7 @@ class CurrentMainCoverageGapTest < Minitest::Test
             with_replaced_singleton_method(Hive::Stages::Review, :reviewer_compare_ref, ->(_cfg, _ops) { "main" }) do
               with_replaced_singleton_method(Hive::Stages::Review, :git_head, ->(_path) { "head-before-fix" }) do
                 with_replaced_singleton_method(Hive::Stages::Review, :worktree_status, ->(_path) { status_checks.shift }) do
-                  with_replaced_singleton_method(Hive::Stages::Review, :spawn_fix_agent, ->(_task, _cfg, _ctx, accepted:) { { status: :ok } }) do
+                  with_replaced_singleton_method(Hive::Stages::Review, :spawn_fix_agent, ->(_task, _cfg, _ctx, accepted:, **_kwargs) { { status: :ok } }) do
                     result = Hive::Stages::Review.run!(task, { "review" => {} })
 
                     assert_equal :review_error, result[:status]
diff --git a/test/unit/events_test.rb b/test/unit/events_test.rb
index 9d5471ad..0ff64063 100644
--- a/test/unit/events_test.rb
+++ b/test/unit/events_test.rb
@@ -48,6 +48,21 @@ class EventsTest < Minitest::Test
     end
   end
 
+  def test_completion_fallback_event_is_an_allowed_stable_event_type
+    with_tmp_dir do |dir|
+      record = Hive::Events.emit(
+        task_folder: dir,
+        slug: "event-test-260522-aaaa",
+        stage: "6-review",
+        event_type: :claude_completion_fallback,
+        message: "phase=review_fix pass=01"
+      )
+
+      assert_equal "claude_completion_fallback", record.fetch("event_type")
+      assert_equal %w[ts slug stage agent event_type message], record.keys
+    end
+  end
+
   def test_status_md_rerenders_latest_event_and_recent_tail
     with_tmp_dir do |dir|
       Hive::Events.emit(task_folder: dir, slug: "event-test-260522-aaaa", stage: "6-review",
